// Bubble shooter
// (c) 2020 Pascal Monasse

#include "piscine.h"
#include <Imagine/Graphics.h>
#include <iostream>

using namespace Imagine;
using namespace std;

// Q1
const int width=30;
const int height=15;

// Q1 Dessine les bords de la piscine
void dessine_cadre() {
    int droite=marge+width*rayon*2+rayon+1;
    drawLine(marge, marge, droite, marge, BLACK);
    int bas=marge+(height-1)*dy+rayon*2;
    drawLine(marge, marge, marge, bas, BLACK);
    drawLine(droite, marge, droite, bas, BLACK);
}

// Efface la zone de la piscine
void efface() {
    fillRect(marge+1,marge+1,
             width*rayon*2+rayon, (height-1)*dy+rayon*2, WHITE);
}

// Q7
void test_affiche() {
    Piscine P(width,height,0);
    while(P.insere_ligne()) {
        efface();
        P.dessine();
        click();
    }
}

// Q11
void test_bulle() {
    Piscine P(width,height,0);
    efface();
    P.dessine();
    P.init_bulle();
    while(P.bouge_bulle()) milliSleep(5);
}

// Q23
void jeu() {
    efface();
    Piscine P(width,height,3);
    P.dessine();
    float probaInsertion=0.2f;
    while(true) {
        P.init_bulle();
        int score0=P.score;
        while(P.bouge_bulle()) milliSleep(5);
        if(P.score==score0) {
            if(rand()/(float)RAND_MAX < probaInsertion) {
                if(! P.insere_ligne())
                    break; // Echec
                efface();
                P.dessine();
                probaInsertion=0.2f;
            } else
                probaInsertion *= 1.2f;
        }
    }
    drawString(marge+width*rayon, height/2*dy+marge, to_string(P.score),
               RED, 50);
}

int main() {
    initRandom();
    openWindow(width*rayon*2+rayon+2*marge,
               (height-1)*dy+rayon*2+marge+margeScore, "Bubbles"); // Q1
    dessine_cadre();
    test_affiche();
    test_bulle();
    jeu();
    endGraphics();
    return 0;
}
